//ObjekteEntfernen_502d.js
// 27.02.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Lscht Objekte ausserhalb der Seiten

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// aktuelles Dokument
var curDoc = app.documents[0];

// die Ebenen entsperren (falls notwendig)
var lockList = new Array ();
var layrLock = curDoc.layers.everyItem().locked;
for (var i=0; i<layrLock.length; i++) {
	if (layrLock[i] == true) {
		curDoc.layers[i].locked = false;
		lockList.push(true);
	}
	else {
		lockList.push(false);
	}
}

// die 'parentPage' aller Objekte
var allParents = curDoc.pageItems.everyItem().parentPage;

// eine Rckwrts-Schleife durch die Attribute
for (var n=allParents.length-1; n>-1; n--) {
	// wenn 'parentPage' leer ist ...
	if (allParents[n] == null) {
		var curObj = curDoc.pageItems[n];
		try {
			var curCont = curObj.contentType*1;
		}
		catch (e) {
			// das Objekt vorsorglich entsperren
			curObj.locked = false;
			// und entfernen
			try {
				curObj.remove();
			}
			catch (e) {
			}
		}
		// wenn es ein Textrahmen ist
		if (curCont == 1952412773) {
			if (curObj.previousTextFrame != null || curObj.nextTextFrame != null) {
				var curStory = curObj.parentStory;
				var allTxtFrames = curStory.textContainers;
				var nTxtFrames = allTxtFrames.length;
				var okay = true;
				for (var t=0; t<nTxtFrames; t++) {
					if (allTxtFrames[t].parentPage != null) {
						okay = false;
						break;
					}
				}
				if (!okay) {
					continue;
				}
			}
		}
		// das Objekt vorsorglich entsperren
		curObj.locked = false;
		// und entfernen
		try {
			curObj.remove();
		}
		catch (e) {
		}
	}
}

// die Ebenen wieder sperren (falls notwendig)
for (var i=0; i<lockList.length; i++) {
	if (lockList[i] == true) {
		curDoc.layers[i].locked = true;
	}
}

// das Ende der Aktion verknden
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();